#!/usr/bin/env python
# -*- coding: utf-8 -*-

#    Copyright (C) <2009>  <Sebastian Kacprzak> <naicik |at| gmail |dot| com>

#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

import unittest
from pluginWrapper import uploadFiles, runMethodInThread, uploadFile



class  PluginWrapperTestCase(unittest.TestCase):
    def setUp(self):
        print "#" * 20 + " NEW TEST " + "#" * 20
    #    self.foo = PluginWrapper_()
    #
    returnValue = None

    def tearDown(self):
        self.returnValue = None
        
    #    self.foo.dispose()
    #    self.foo = None
    def noArgsFunction(self):
        print "noArgsFunction"
        self.returnValue = True
        
    def oneArgsFunction(self, arg1):
        print "oneArgsFunction", arg1
        self.returnValue = arg1

    def exceptionRaisngFunction(self):
        print "exceptionRaisngFunction"
        raise Exception

    def test_runMethodInThread_dummyFunction(self):
        print "runMethodInThread_dummyFunction"
        #assert x != y;
        #self.assertEqual(x, y, "Msg");
        t = runMethodInThread(self.noArgsFunction,(),self.fail,"shouldnt give any error")
        t.join()
        self.assertTrue(self.returnValue, "dummyFunction wasn't called")

    def test_runMethodInThread_exceptionRaisngFunction(self):
        print "runMethodInThread_exceptionRaisngFunction"
        t = runMethodInThread(self.exceptionRaisngFunction,(),self.oneArgsFunction, True)
        t.join()
        self.assertTrue(self.returnValue, "errorCalback wasn't called")
        
    def test_uploadFiles(self):
        print "uploadFiles"
        uploader = DummyUploader()
        file1 = "1.txt"
        file2 = "2.png"
        files = [file1, file2]
        threadList = uploadFiles(uploader, self.fail, files, self.oneArgsFunction, None, 0, None, None, None)
        for thread in threadList:
            thread.join() # wait for all threads to end
        self.assertTrue(self.returnValue, "dummyFunction wasn't called")
        self.assertEqual(len(uploader.arguments), 2, "should be called two times")
        assert [file1,self.oneArgsFunction,None,0,None,None,None] in uploader.arguments
        assert [file2,self.oneArgsFunction,None,1,None,None,None] in uploader.arguments 
        #self.assertEqual(uploader.arguments[0], [file1,self.oneArgsFunction,None,0,None,None,None])
        #self.assertEqual(uploader.arguments[1], [file2,self.oneArgsFunction,None,1,None,None,None])

    def test_uploadFiles_raisingException(self):
        print "uploadFiles_raisingException"
        uploader = DummyUploaderRaisngException()
        file1 = "1.txt"
        files = [file1]
        exceptedReturnValue = 123
        threadList = uploadFiles(uploader, self.oneArgsFunction, files, self.fail, None, exceptedReturnValue, None, None, None)
        for thread in threadList:
            thread.join() # wait for all threads to end
        self.assertEqual(self.returnValue, exceptedReturnValue, "exception wasnt catched by wrapper")
        
    def test_uploadFiles(self):
        print "uploadFiles"
        uploader = DummyUploader()
        file1 = "1.txt"
        t = uploadFile(uploader, self.fail, file1, self.oneArgsFunction, None, 0, None, None, None)
        t.join()
        self.assertTrue(self.returnValue, "dummyFunction wasn't called")
        self.assertEqual(len(uploader.arguments), 1, "should be called only once")
        self.assertEqual(uploader.arguments[0], [file1,self.oneArgsFunction,None,0,None,None,None])

    def test_uploadFile_raisingException(self):
        print "uploadFile_raisingException"
        uploader = DummyUploaderRaisngException()
        file1 = "1.txt"
        exceptedReturnValue = 123
        t = uploadFile(uploader, self.oneArgsFunction, file1, self.fail, None, exceptedReturnValue, None, None, None)
        t.join()
        self.assertEqual(self.returnValue, exceptedReturnValue, "exception wasnt catched by wrapper")
        

class DummyUploader():
    """mock object simulating well behaving uploader module"""
    arguments = []

    def uploadFile(self, file, resultCallbackFunction, progressCallbackFunction, fileNumber, semaphore, username, password):
        print "uploadFile dummyUploader"
        self.arguments.append([file, resultCallbackFunction, progressCallbackFunction,fileNumber,semaphore,username, password])
        resultCallbackFunction(True)

class DummyUploaderRaisngException():
    """mock object simulating failning uploader module"""
    arguments = []

    def uploadFile(self, file, resultCallbackFunction, progressCallbackFunction, fileNumber, semaphore, username, password):
        print "uploadFile dummyUploaderRaisngException"
        self.arguments.append([file, resultCallbackFunction, progressCallbackFunction,fileNumber,semaphore,username, password])
        raise Exception


if __name__ == '__main__':
    unittest.main()

