#!/usr/bin/env python
# -*- coding: utf-8 -*-

#    Copyright (C) <2009>  <Sebastian Kacprzak> <naicik |at| gmail |dot| com>

#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

import unittest

from uploadHelper import createLinks

class  UploadHelperTestCase(unittest.TestCase):

    def test_uploadHelper(self):
        #assert x != y;
        #self.assertEqual(x, y, "Msg");
        fileDownloadLink = "http://img4.imageshack.us/my.php?image=26340702.png"
        fileName = "t.png"
        imageLink = "http://img4.imageshack.us/img4/5088/26340702.png"
        thumbLink = None
        links = createLinks(fileDownloadLink, fileName, imageLink, thumbLink)
        self.assertEqual(len(links), 8)
        self.assertEqual(links[0], fileDownloadLink)
        self.assertEqual(links[1], "[URL=http://img4.imageshack.us/my.php?image=26340702.png][IMG]http://img4.imageshack.us/img4/5088/26340702.png[/IMG][/URL]")
        self.assertEqual(links[2], "[URL=http://img4.imageshack.us/my.php?image=26340702.png][IMG=http://img4.imageshack.us/img4/5088/26340702.png][/IMG][/URL]")
        self.assertEqual(links[3], "<a target='_blank' href='http://img4.imageshack.us/my.php?image=26340702.png'><img src='http://img4.imageshack.us/img4/5088/26340702.png' border='0'/></a>")
        self.assertEqual(links[4], imageLink)
        self.assertEqual(links[5], "[URL=http://img4.imageshack.us/my.php?image=26340702.png][IMG]http://img4.imageshack.us/img4/5088/26340702.png[/IMG][/URL]")
        self.assertEqual(links[6], "[URL=http://img4.imageshack.us/my.php?image=26340702.png][IMG=http://img4.imageshack.us/img4/5088/26340702.png][/IMG][/URL]")
        self.assertEqual(links[7], "'<a target='_blank' href='http://img4.imageshack.us/my.php?image=26340702.png'><img src='http://img4.imageshack.us/img4/5088/26340702.png' border='0'/></a>")


        thumbLink = "http://img4.imageshack.us/thumb.png"
        links = createLinks(fileDownloadLink, fileName, imageLink, thumbLink)
        self.assertEqual(len(links), 8)
        self.assertEqual(links[0], fileDownloadLink)
        self.assertEqual(links[1], "[URL=http://img4.imageshack.us/my.php?image=26340702.png][IMG]http://img4.imageshack.us/img4/5088/26340702.png[/IMG][/URL]")
        self.assertEqual(links[2], "[URL=http://img4.imageshack.us/my.php?image=26340702.png][IMG=http://img4.imageshack.us/img4/5088/26340702.png][/IMG][/URL]")
        self.assertEqual(links[3], "<a target='_blank' href='http://img4.imageshack.us/my.php?image=26340702.png'><img src='http://img4.imageshack.us/img4/5088/26340702.png' border='0'/></a>")
        self.assertEqual(links[4], imageLink)
        self.assertEqual(links[5], "[URL=http://img4.imageshack.us/my.php?image=26340702.png][IMG]http://img4.imageshack.us/thumb.png[/IMG][/URL]")
        self.assertEqual(links[6], "[URL=http://img4.imageshack.us/my.php?image=26340702.png][IMG=http://img4.imageshack.us/thumb.png][/IMG][/URL]")
        self.assertEqual(links[7], "'<a target='_blank' href='http://img4.imageshack.us/my.php?image=26340702.png'><img src='http://img4.imageshack.us/thumb.png' border='0'/></a>")

        links = createLinks(fileDownloadLink)
        self.assertEqual(len(links), 4)
        self.assertEqual(links[0], fileDownloadLink)
        self.assertEqual(links[1], "[URL=http://img4.imageshack.us/my.php?image=26340702.png]http://img4.imageshack.us/my.php?image=26340702.png[/URL]")
        self.assertEqual(links[2], "[URL=http://img4.imageshack.us/my.php?image=26340702.png]http://img4.imageshack.us/my.php?image=26340702.png[/URL]")
        self.assertEqual(links[3], "<a target='_blank' href='http://img4.imageshack.us/my.php?image=26340702.png'>http://img4.imageshack.us/my.php?image=26340702.png</a>")

        links = createLinks(fileDownloadLink, fileName)
        self.assertEqual(len(links), 4)
        self.assertEqual(links[0], fileDownloadLink)
        self.assertEqual(links[1], "[URL=http://img4.imageshack.us/my.php?image=26340702.png]t.png[/URL]")
        self.assertEqual(links[2], "[URL=http://img4.imageshack.us/my.php?image=26340702.png]t.png[/URL]")
        self.assertEqual(links[3], "<a target='_blank' href='http://img4.imageshack.us/my.php?image=26340702.png'>t.png</a>")


if __name__ == '__main__':
    unittest.main()

